/* Copyright (C) 2001,2008 Martijn van Iersel and Jules Beulen
 * This program is released under the terms of the zlib license
 * See license.txt for details
 */
#include "particle.h"

void Particle::init ()
{
    int i;
    for (i = 0; i < part_max; i++)
    {
        partx[i] = rand() % SCREEN_W;
        partdx[i] = rand() % 10 + 1;
        party[i] = rand() % SCREEN_H;
        partdy[i] = 0;
        partc[i] = (partdx[i] - 1) / 2 + 241;
    }
}

void Particle::update ()
{
    int i;
    for (i = 0; i < part_max; i++)
    {
        partx[i] += partdx[i];
        party[i] += partdy[i];
        if (partx[i] >= SCREEN_W)
        {
            partx[i] = 0;
        }
    }
}

void Particle::draw (BITMAP *buffer)
{
    int i;
    for (i = 0; i < part_max; i++)
    {
        putpixel (buffer, partx[i], party[i], partc[i]);
    }
}

